﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CustomDateTime
{
    public partial class Form1 : Form
    {
        private IList<MyEntity> _datasource = new List<MyEntity>()
        {
            new MyEntity() { Date = DateTime.Today },
        };

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = _datasource;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle.ResizeAllColumns;

            e.Layout.Bands[0].Columns["Date"].EditorComponent = phDateTimeEditorForGrid;
            //e.Layout.Bands[0].Columns["Date"].Format = "nnnn\\-nn\\-nn";
            e.Layout.Bands[0].Columns["Date"].Editor.ExpectedType = typeof(DateTime);
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            var val = e.Row.Cells["Date"].Value;
            if (val != null && val is DateTime)
            {
                ultraLabel1.Text = String.Format("Date in grid: {0}", ((DateTime)val).ToString("yyyy-MM-dd"));
            }
            else
            {
                ultraLabel1.Text = "Date in grid: null or invalid";
            }
        }

        private void ultraGrid1_BeforeCellUpdate(object sender, Infragistics.Win.UltraWinGrid.BeforeCellUpdateEventArgs e)
        {

        }

        private void ultraGrid1_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            var val = e.Cell.Value;
            if (val != null && val is DateTime)
            {
                ultraLabel1.Text = String.Format("Date in grid: {0}", ((DateTime)val).ToString("yyyy-MM-dd"));
            }
            else
            {
                ultraLabel1.Text = "Date in grid: null or invalid";
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
